package gameCanvasUtil;

import java.io.*;

import javax.sound.midi.*;

/** midiǗAĐȂǂs
 *
 */
public class midiManager  implements soundManagerInterface{
	// RXgN^Ŏw肳ꂽt@Cێ
	private String fileName;

	//炷V[PT[
	private Sequencer sequencer[];
	private Synthesizer synthesizer = null;

	//ƂɃ[v邩̃tO
	private boolean loop_flag[];

	//Ƃ̉
	private int volume[];


	//TEh̐
	private static final int MIDI_MAX_NUM = 64;
	//MIDI̎dlŁATEhʕύX
	private static final int CHANGE_VOLUME = 7;

	/** 摜Ȃǂ悫Ɍv炦 **/
	public static final int NUMBER_AUTO_CULC = -1;
	/** 摜XgeLXgǂݍ݂₪ */
	public static final int READ_LIST_FROM_TEXT = -2;

	/** RXgN^
	 * @param file ǂݍޘAMIDIt@Cw
	 * @param number MIDI̎wB
	 * t@CɂȂ邩킩Ȃꍇ"NUMBER_AUTO_CULC"w肷Ƃ悫Ɍv炢܂B<br />
	 * ܂ READ_LIST_FROM_TEXT w肷ƘAԃt@Cǂݍ݂ł͂ȂA"file"<br />
	 * MIDĨXgĂeLXgt@CƂēǂݍ݁ÃXgɏ]MIDIǂݍ݂܂B<br />
	 * (Xg͈s1t@CĂłB)
	 */
	public midiManager(String file,int number){
		this.fileName = file;
		if(number==NUMBER_AUTO_CULC){
			sequencer = new Sequencer[MIDI_MAX_NUM];
			loop_flag = new boolean[MIDI_MAX_NUM];
			volume = new int[MIDI_MAX_NUM];
			this.loadNumberingMidi(false);

		}else if(number==READ_LIST_FROM_TEXT){
			String list[] = saveDataUtil.readResourceStrings(file);
			sequencer = new Sequencer[list.length];
			loop_flag = new boolean[list.length];
			volume = new int[number];
			for(int i=0;i<list.length;i++){
				sequencer[i] = loadMidi(list[i]);
			}
		}else{
			sequencer = new Sequencer[number];
			loop_flag = new boolean[number];
			volume = new int[number];
			this.loadNumberingMidi(true);
		}
		initSynthesizer();
	}


	/** AMIDI[h
	 * @param skip ǂݍ߂ȂꍇXLbv邩H
	 * ꂪfalseƁAǂݍ߂ȂƁAŏIB
	 */
	private void loadNumberingMidi(boolean skip){
		for(int i=0;i<MIDI_MAX_NUM;i++){
			this.sequencer[i] = loadMidi(this.fileName +i+".mid");
			if(this.sequencer[i]==null && !skip)
				break;
		}
	}

	/** MIDI[h
	 * @param id MIDIIDw肷
	 * @return ǂݍMIDIIuWFNgԂ
	 */
	private Sequencer loadMidi(String file){
		Sequencer tmp;
		try{
			tmp = MidiSystem.getSequencer();
			tmp.open();
			InputStream is=null;
			is = this.getClass().getResourceAsStream("/"+file);
			Sequence s = MidiSystem.getSequence(is);
			tmp.setSequence(s);
			is.close();
			return tmp;
		}catch(Exception e){
			System.out.println( "loadMidi "+file +" "+e);
			return null;
		}
	}

	/** MIDIĐ
	 * @param id MIDIIDw
	 * @param flag [vsZbgBsȂtrueB
	 */
	public void playSound(int id,boolean flag){
		try{
			this.loop_flag[id] = flag;
			sequencer[id].start();
		}catch(Exception e){
			e.printStackTrace();
		}
	}

	/** midiꎞ~
	 * @param id ~MIDIw肷
	 */
	public void pauseSound(int id){
		try{
			if(this.sequencer[id]!=null)
				this.sequencer[id].stop();
		}catch(Exception e){
		}
	}

	/** MIDI~
	 * @param id ~MIDIw肷
	 */
	public void stopSound(int id){
		try{
			if(this.sequencer[id]!=null){
				this.sequencer[id].stop();
				this.sequencer[id].setTickPosition(0);
			}
		}catch(Exception e){
		}
	}

	/** MIDỈʂZbg
	 * @param id MIDIIDw
	 * @param vol ʂw(0-100)
	 */
	public void changeVolume(int id,int vol){
		if(vol < 0){
			vol = 0;
		}else if(vol > 127){
			vol = 127;
		}
		volume[id] = (vol * 127) / 100;
	}

	/** MIDỈʂZbg
	 * @param id MIDIIDw
	 * @param vol ʂw(0-100)
	 */
	private void setVolume(int id,int vol){
		if(sequencer[id]==null){
			return;
		}
		int midiVolume = vol;
		try{
			if( synthesizer.getDefaultSoundbank() == null ){
				// HARDWARE SYNTHESIZER
				try{
					ShortMessage volumeMessage = new ShortMessage();
					for( int i = 0; i < 16; i++ ){
						volumeMessage.setMessage( ShortMessage.CONTROL_CHANGE,
												  i, CHANGE_VOLUME, midiVolume );
						MidiSystem.getReceiver().send( volumeMessage, -1 );
					}
				}
				catch( InvalidMidiDataException imde ){
					System.err.println( "Invalid MIDI data." );
					return;
				}
				catch( MidiUnavailableException mue ){
					System.err.println( "MIDI unavailable." );
					return;
				}
			}
			else{
				// SOFTWARE SYNTHESIZER:
				MidiChannel[] channels = synthesizer.getChannels();
				for( int c = 0; channels != null && c < channels.length; c++ ){
					channels[c].controlChange( CHANGE_VOLUME, midiVolume );
				}
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}


	/** TEh̍XV
	 */
	public void update(){
		for(int i=0;i<sequencer.length;i++){
			try{
				setVolume(i,volume[i]);
				if(sequencer[i]!=null && sequencer[i].getTickLength() <= sequencer[i].getTickPosition() ){
					this.sequencer[i].stop();
					this.sequencer[i].setTickPosition(0);
					this.sequencer[i].start();
				}
			}catch(Exception e){
			}
		}
	}

	/** SẴTEhꎞ~
	 */
	public void pauseSound(){
		for(int i=0;i<this.sequencer.length;i++){
			pauseSound(i);
		}
	}

	/** SẴTEh~
	 */
	public void stopSound(){
		for(int i=0;i<this.sequencer.length;i++){
			stopSound(i);
		}
	}
	/** SẴTEh̉ʕύX
	 */
	public void changeVolume(int vol){
		for(int i=0;i<this.sequencer.length;i++){
			this.changeVolume(i, vol);
		}
	}

	/** VZTCU[̏
	 */
	private void initSynthesizer(){
		try{
			if (!(sequencer[0] instanceof Synthesizer)){
				synthesizer = MidiSystem.getSynthesizer();
				synthesizer.open();
				if( synthesizer.getDefaultSoundbank() == null )	{
					// HARDWARE SYNTHESIZER
					for(int i=0;i<sequencer.length;i++){
						sequencer[i].getTransmitter().setReceiver(
							MidiSystem.getReceiver() );
					}
				}
				else{
					// SOFTWARE SYNTHESIZER
					for(int i=0;i<sequencer.length;i++){
						sequencer[i].getTransmitter().setReceiver(
							synthesizer.getReceiver() );
					}
				}
			}else{
				synthesizer = (Synthesizer) sequencer[0];
			}
		}catch(Exception e){
		}
	}

}
